
/*
 * Copyright (c) Developers of JPolynomial
 * Redistributable and modifiable. Please see license.readme for details.
 *
 * ammendment history
 * <date>			<changed by>		<summary of changes>
 * 27 August 2004	Jonee Ryan Ty		First documented history
 *
 */

//import java.util.Stack;

//import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JButton;
//import javax.swing.JTextArea;

/**
 * This is just a frame port of App. If you want to fix a bug please fix it in 
 * App first. Modifications in here should only be porting related.
 */
public class Frm	extends PolyFrm
{
    private static final int MAX_ITERATION = 50;
	
	private int iteration = 0;
	
	private boolean isOdd = true,	// used for tabs in getNextStop
					isIterating = false,
					isN = false;
					
	private String prevText;
	private JRadioButton current;
					
    public void actionPerformed(java.awt.event.ActionEvent e) {

        Object source = e.getSource();
		String buttonLabel;
		boolean isOkLabel = false;

        if (source instanceof JRadioButton) {	

            if (activeDialog == dProperties) {	// axis type changed
                if (rNormal.isSelected())
                    polyCanv.typeOfAxis = PolyCanv.NORMAL;

                else if (rFramed.isSelected())
                    polyCanv.typeOfAxis = PolyCanv.FRAMED;

                else if (rNone.isSelected())
                    polyCanv.typeOfAxis = PolyCanv.NONE;

                polyCanv.repaint();
                return;
            }

            bIterate.setEnabled(!(rTraverse.isSelected()) && 
                !(rValue.isSelected()));
                
			bN.setEnabled(!(rTraverse.isSelected()) && 
                !(rValue.isSelected()));                
			
			if (source != current)
				stopIteration();
				
			return;	
        }

		if (outputShown) {
    		if (source == bHide) {
				hideOutput();
            	tToSketch.requestFocus();
            	return;						
		
			} else if (source == bClear) {
				text.setText("");
				return;
		
			} else if (source == bCopy) {
				showErrorMsg(Constants.FIX_ME);
				return;
			
			} else if (source == bCopyAll) {
				showErrorMsg(Constants.FIX_ME);
				return;
		
			} else if (source == bPrint) {
				showErrorMsg(Constants.FIX_ME);				
				return;
			}			
		}

		if (source == bC) {		
			tToSketch.setText("");
			tToSketch.requestFocus();
			stopIteration();
			return;
		
		} else if (source == bShow) {
			stopIteration();
        	showOutput();
    		return;    		
    	} 
    					    	
        if (tToSketch.getText().length() == 0) {	//nothing to graph
            polyCanv.fToGraph = null;
            polyCanv.repaint();
            return;        
        } 

        if (source == showLabels) {
            polyCanv.showLabels = showLabels.isSelected();
            polyCanv.repaint();
            return;
        }

        try {
            poly = new Polynomial(tToSketch.getText().trim());
        } catch (IllegalArgumentException err) {
            showErrorMsg(err.getMessage());
            return;
        }

	    if (source == bIterate) {
			if (iteration == 0) {
				
				polyCanv.fToGraph = poly;
				polyCanv.repaint();
				
	            if (rMulti.isSelected()) {	            	
        	        tMultiDegree.setEditable(false);
					isIterating = true;
            	    current = rMulti;
            	    makeActive(dMulti);            	    

	            } else if (rNewton.isSelected()) {
        	        tNewtonTolerance.setEditable(false);
					isIterating = true;
            	    current = rNewton;
            	    makeActive(dNewton);            	    

            	} else if(rSecant.isSelected()) {
                	tSecantTolerance.setEditable(false);
					isIterating = true;
                	current = rSecant;
                	makeActive(dSecant);                	
            	}			
			
			} else 
				doIteration();
			        	
        	return;
        	        
        } else if (source == bPrevious)
        	doPrevious();
        
        else if (source instanceof JButton) {
        	buttonLabel = ((JButton)source).getText();

        	if (!buttonLabel.equals(Constants.OK_LABEL)) {
        		stopIteration();
        	} else
        		isOkLabel = true;
        		
        } else
        	stopIteration();	        	                

        if ((source == tToSketch) || (source == bToGraph)) {
            polyCanv.fToGraph = poly;
            polyCanv.repaint();
            
            updateTextFields();        

        } else if (source == bToNestedForms) {

            tfxToNested.setText(poly.fxToNestedForm());
            tfpxToNested.setText(poly.fpxToNestedForm()); 			
            makeActive(dToNested);
            bOk[0].requestFocus();

        } else if (source == bToEval) {
            makeActive(dToEval);        
            tx.requestFocus();

        } else if (source == bN) {
			
			polyCanv.fToGraph = poly;	
        	polyCanv.repaint();
        	
        	if (rMulti.isSelected()) {
        		lMulti.setText(" iteration: ");
				prevText = tMultiDegree.getText();
				tMultiDegree.setText("10");						
				isN = true;
            	
                makeActive(dMulti);            	    
			
			} else if (rNewton.isSelected()) {
        	   	lNewton.setText(" iteration: ");
				prevText = tNewtonTolerance.getText();
				tNewtonTolerance.setText("10");					
				isN = true;
					
                makeActive(dNewton);            	    

            } else if(rSecant.isSelected()) {
               	lSecant.setText(" iteration: ");
				prevText = tSecantTolerance.getText();
				tSecantTolerance.setText("10");
				isN = true;                
					
               	makeActive(dSecant);                	
            }			
        
        } else if ((source == bHorner) || (source == tx)) {
                        
            try {
                double num = Double.parseDouble(tx.getText().trim());

                tfx.setText(Double.toString(poly.f(num)));
                tfpx.setText(Double.toString(poly.fp(num)));

            } catch (NumberFormatException nfe) {            	
                showErrorMsg(Constants.NUMBER_FORMAT_EX);
                tx.requestFocus();
                return;
            }

        } else if (source == bProperties) {
            tx1.setText(Double.toString(polyCanv.lowX));
            tx2.setText(Double.toString(polyCanv.highX));
            makeActive(dProperties);
            
            tx1.requestFocus();

        } else if (source == bDo) {

            if (rTraverse.isSelected())                
                makeActive(dTraverse);

            else if (rValue.isSelected()) 
                makeActive(dValue);

            else if (rMulti.isSelected()) 
                makeActive(dMulti);

            else if (rNewton.isSelected())
                makeActive(dNewton);

            else // if rSecant
                makeActive(dSecant);
        	
        } else if (source instanceof JButton) { 
                // if source is an ok or cancel button
            JButton target = (JButton)source;

            if (!isOkLabel) {		// not an ok button
                
                if (isN) {
                	updateNTextFields();
                	isN = false;
                }
                
                activeDialog.hide();
                tToSketch.requestFocus();
                return;
            }
            
            double x1, x2, y1, y2;

            if (activeDialog == dToEval) {
                tx.setText("");
                tfx.setText("");
                tfpx.setText("");
                hideActiveDialog();

			} else if (activeDialog == dToNested) {
				hideActiveDialog();
				
            } else if (activeDialog == dProperties) {
                int count = 0;
                try {
                    x1 = Double.parseDouble(tx1.getText().trim());
                    count++;
                    x2 = Double.parseDouble(tx2.getText().trim());
                    count++;
                    y1 = Double.parseDouble(ty1.getText().trim());
                    count++;
                    y2 = Double.parseDouble(ty2.getText().trim());

                } catch (NumberFormatException nfe) {		
                    showErrorMsg(Constants.NUMBER_FORMAT_EX);
                    
                    if (count == 0)
                    	tx1.requestFocus();
                    else if (count == 1)
                    	tx2.requestFocus();
                    else if (count == 2)
                    	ty1.requestFocus();
					else if (count == 3)
                    	ty2.requestFocus();                    	
                    	                    		
                    return;
                }

                if ((x1 == x2) || (y1 == y2)) {				
					showErrorMsg(Constants.INTERVAL_EX);
                    return;
                }

                if ((x1 > x2) || (y1 > y2)) {
                    if (x1 > x2) {
                        polyCanv.lowX 	= x2;
                        polyCanv.highX 	= x1;

                        tx1.setText(Double.toString(x2));
                        tx2.setText(Double.toString(x1));
                    }

                    if (y1 > y2) {
                        polyCanv.lowY 	= y2;
                        polyCanv.highY 	= y1;

                        ty1.setText(Double.toString(y2));
                        ty2.setText(Double.toString(y1));
                    }

                    return;

                } else {
                    polyCanv.lowX 	= x1;
                    polyCanv.highX 	= x2;

                    polyCanv.lowY 	= y1;
                    polyCanv.highY 	= y2;
                }

                polyCanv.repaint();                
                hideActiveDialog();

            } else if (activeDialog == dTraverse) {
                
                int count = 0;
                
                try {
                    x1 = Double.parseDouble(tTraverseX1.getText().trim());
                    count++;
                    x2 = Double.parseDouble(tTraverseX2.getText().trim());

                } catch (NumberFormatException nfe) {		
					showErrorMsg(Constants.NUMBER_FORMAT_EX);
					
					if (count == 0)
						tTraverseX1.requestFocus();
					else
						tTraverseX2.requestFocus();
						
                    return;
                }

                if (x1 == x2) {						
                    showErrorMsg(Constants.INTERVAL_EX);
                    return;
                }

                if (x1 > x2) {
                    polyCanv.lowX 	= x2;
                    polyCanv.highX 	= x1;

                    tTraverseX1.setText(Double.toString(x2));
                    tTraverseX2.setText(Double.toString(x1));

                    return;

                } else {
                    polyCanv.lowX 	= x1;
                    polyCanv.highX 	= x2;
                    polyCanv.fToGraph = poly;
                    polyCanv.repaint();

                    print("\n traversing f(x) = " +
                        polyCanv.fToGraph.toString() + " in the interval [" +
                        Double.toString(polyCanv.lowX) + "," +
                        Double.toString(polyCanv.highX) + "]");

					activeDialog.hide();
            		tToSketch.requestFocus();
            		
                    TraversalThread t = new TraversalThread(polyCanv, this);
                    t.start();
                    return;
                }

            } else if (activeDialog == dValue) {
                int base, deg, count = 0;

                try {
                    x1 = Double.parseDouble(tValueX1.getText().trim());
                    count++;
                    x2 = Double.parseDouble(tValueX2.getText().trim());
                    count++;
                    deg = Integer.parseInt(tValueDegree.getText().trim());
                    count++;
                    base = Integer.parseInt(tValueBase.getText().trim());

                } catch (NumberFormatException nfe) {	
                    showErrorMsg(Constants.NUMBER_FORMAT_EX);
                    
                    if (count == 0)
                    	tValueX1.requestFocus();	
                    else if (count == 1)
                    	tValueX2.requestFocus();
                    else if (count == 2)
                    	tValueDegree.requestFocus();
                    else if (count == 3)
                    	tValueBase.requestFocus();
                    return;
                }

                if ((x1 == x2) || (deg < 1) || (base < 2)) {
					showErrorMsg(Constants.INTERVAL_EX2);
                    return;
                }

                if (x1 > x2) {
                    tValueX1.setText(Double.toString(x2));
                    tValueX2.setText(Double.toString(x1));

                    return;
                }

                if (poly.f(x1) * poly.f(x2) < 0) {

                    print("\n base " + base +
                        " value differentiation in the interval [" + x1 +
                        "," + x2 + "] for " + poly.toString() +
                        " with degree of accuracy equal to " + deg);
                    print("iteration              increment" + getNextStop() + 
                    	"x" + getNextStop() + "f(x)");

                    double increment;
                    int a = 1;
                                        // check the number of iterations
                    while (Math.pow(base, -a) > 5 * Math.pow(10, -(deg + 1)))
                        a++;

                    if (poly.f(x1) < 0) {			
                                //Math.log is the natural log
                        for (int b = -(int)(Math.log(x2 - x1) / Math.log(base));
                                b < a + 1; b++) {
                            increment = Math.pow(base, -b);

                            while (poly.f(x1 + increment) < 0)
                                x1 += increment;

                            if (poly.f(x1 + increment) == 0) {
																		
                                print(b + getPad(b) + increment + 
                                	getNextStop() + (x1 + increment) + 
                                	getNextStop() + poly.f(x1 + increment));

                                b = a + 1;	// to terminate loop

                            } else {							
																		
                                print(b + getPad(b) + increment +
                                    getNextStop() + x1 + getNextStop() + 
                                    poly.f(x1));
                            }
                        }

                    } else {
                                //Math.log is the natural log
                        for (int c = -(int)(Math.log(x2 - x1) / Math.log(base));
                                c < a + 1; c++) {
                            increment = Math.pow(base, -c);

                            while (poly.f(x1 + increment) > 0)
                                x1 += increment;

                            if (poly.f(x1 + increment) == 0) {
																		
                                print(c + getPad(c) + increment + 
                                	getNextStop() + (x1 + increment) + 
                                	getNextStop() + poly.f(x1));

                                c = a + 1;	// to terminate loop

                            } else {
																		
                                print(c + getPad(c) + increment + 
                                	getNextStop() + x1 + getNextStop() + 
                                	poly.f(x1));
                            }
                        }
                    }
					
					hideActiveDialog();
					showOutput();
					
                } else {
	            	showErrorMsg(Constants.IVT_EX);
	            	return;
                }

            } else if (activeDialog == dMulti) {
				
                int base, deg = 0, count = 0;

                try {
                    x1 = Double.parseDouble(tMultiX1.getText().trim());
                    count++;
                    x2 = Double.parseDouble(tMultiX2.getText().trim());
                    count++;
                    base = Integer.parseInt(tMultiParts.getText().trim());
                    count++;
                    deg = Integer.parseInt(tMultiDegree.getText().trim());

                } catch (NumberFormatException nfe) { 
					showErrorMsg(Constants.NUMBER_FORMAT_EX);
					
					if (count == 0)
						tMultiX1.requestFocus();
					else if (count == 1)
						tMultiX2.requestFocus();
					else if (count == 2)
						tMultiParts.requestFocus();
					else if (count == 3)
						tMultiDegree.requestFocus();
					
                    return;
                }

                if (isN && deg < 2) {
                	showErrorMsg(Constants.N_ERROR);
                	return;
                	
                } else if ((x1 == x2) || (deg < 1) || (base < 2)) {
					showErrorMsg(Constants.INTERVAL_EX2);
                    return;
                }

                if (x1 > x2) {
                    tMultiX1.setText(Double.toString(x2));
                    tMultiX2.setText(Double.toString(x1));

                    return;
                }

                if (poly.f(x1) * poly.f(x2) < 0) { 

					if (isIterating) {

						hideActiveDialog();
						doIteration();
						return;
					
					} else if (isN) {
						hideActiveDialog();
						doN(deg);
						return;
					}
					
						
                    print("\n " + base +
                        "-section method in the interval [" + x1 +
                        "," + x2 + "] for " + poly.toString() +
                        " with degree of accuracy equal to " + deg);
                    print("iteration              a" + getNextStop() + 
	                    "b" + getNextStop() + "(b - a)");

                    int d = 1;	//count the number of iterations

                    while ((x2 - x1) * Math.pow(base, -d) >
                            5 * Math.pow(10, -(deg + 1)))
                        d++;

                    double length = (x2 - x1) / base;

                    int f = 0;

                    while (f < d) {
                        for (int g = 0; g < base; g++) {
                            x2 = x1 + length;

                            if (poly.f(x1) == 0) {
                                g = base + 1; // to terminate inner loop
                                f = d; // to terminate outer loop
																
                                print("f(" + x1 + ") = 0.0");

                            } else if (((poly.f(x1) < 0) && (poly.f(x2) > 0)) ||
                                    ((poly.f(x1) > 0) && (poly.f(x2) < 0))) {
                                        // to find first IVT sub-interval
                                g = base + 1; // to terminate inner loop
																		
                                print((f + 1) + getPad(f + 1) + x1 +
                                	getNextStop() + x2 + getNextStop() +
                                	(x2 - x1));  

                                continue; //skip incrementation
                            }

                            x1 = x2;
                        }

                        length = (x2 - x1) / base;
                        f++;
                    }						
					
					hideActiveDialog();
					showOutput();

                } else {	
                	showErrorMsg(Constants.IVT_EX); 
                    return;
                }
	        // else if(activeDialog == dMulti);
    	    } else if (activeDialog == dNewton) {

        	    int initial, count = 0, n = 0;
            	double tolerance = 0.1;

            	try {
                	initial	= Integer.parseInt(tInitial.getText().trim());
                	count++;
                	
                	if (isN)
                		n = Integer.parseInt(tNewtonTolerance.getText().trim());
                	
                	else 
                		tolerance = 
                		  Double.parseDouble(tNewtonTolerance.getText().trim());

            	} catch (NumberFormatException nfe) {
					showErrorMsg(Constants.NUMBER_FORMAT_EX);
					
					if (count == 0)
						tInitial.requestFocus();
					else
						tNewtonTolerance.requestFocus();
							
                	return;
            	}

				if (isN && n < 2) {
                	showErrorMsg(Constants.N_ERROR);
                	return;
                	
                } else if ((tolerance < 0) || (tolerance > 1)) {
                    showErrorMsg(Constants.TOLERANCE_EX); 
                    return;
                }

                if (isIterating) {
					hideActiveDialog();
					doIteration();
					return;
				
				} else if (isN) {
					hideActiveDialog();
					doN(n);
					return;
				}
					
                print("\n Newton's iteration for " + poly.toString() +
                    " with tolerance equal to " + tolerance);
                print("iteration              x" + getNextStop() + "f(x)" +
                	getNextStop() + "x - xPrev");
                print("0" + getPad(0) + initial + getNextStop() + 
                	poly.f(initial) + getNextStop());

                tolerance /= Constants.ERROR_FACTOR;

                if ((poly.f(initial) == 0) || (poly.fp(initial) == 0)) {
                    
                    if(poly.fp(initial) == 0)
                        print(Constants.ZERO_DERIV);
					
					hideActiveDialog();
					showOutput();
            
                    return;
                }

                double xn, xPrev = initial;

                for (int g = 1; g < MAX_ITERATION; g++) {
                    if (poly.fp(xPrev) == 0) {

                        print(Constants.ZERO_DERIV);			

                        g = MAX_ITERATION;

                    } else {
                        xn = xPrev - poly.f(xPrev) / poly.fp(xPrev);
																
                        print(g + getPad(g) + xn + getNextStop() +
                            poly.f(xn) + getNextStop() + (xn - xPrev));

                        if ((Math.abs(xn - xPrev) < tolerance) || 
                                (poly.f(xn) == 0))
                            g = MAX_ITERATION;

                        xPrev = xn;
                    }
                }	
				
				hideActiveDialog();
				showOutput();

            //else if(activeDialog == dNewton)
            } else if (activeDialog == dSecant) {

                double x3, tolerance = 0.1; // x1, x2 already defined
                int count = 0, n = 0;

                try {
                    x1 = Double.parseDouble(tSecantX0.getText().trim());
                    count++;
                    x2 = Double.parseDouble(tSecantX1.getText().trim());
                    count++;
                    
                    if (isN)
                    	n = Integer.parseInt(tSecantTolerance.getText().trim());
                    else
                    	tolerance = 
                    	  Double.parseDouble(tSecantTolerance.getText().trim());
                    count++;

                } catch (NumberFormatException nfe) {
					showErrorMsg(Constants.NUMBER_FORMAT_EX);
					
					if (count == 0)
						tSecantX0.requestFocus();
					else if (count == 1)
						tSecantX1.requestFocus();
					else if (count == 2)
						tSecantTolerance.requestFocus();
					
                    return;
                }
                
                if (isN && n < 2) {
                	showErrorMsg(Constants.N_ERROR);
                	return;
                
                } else if ((tolerance < 0) || (tolerance > 1) || (x1 == x2)) {
					showErrorMsg(Constants.TOLERANCE_EX2);
                    return;
                }

				if (isIterating) {
					hideActiveDialog();
					doIteration();
					return;
				
				} else if (isN) {
					hideActiveDialog();
					doN(n);
					return;
				}

                print("\n secant iteration for " +
                    poly.toString() + " with tolerance equal to " +
                    tolerance);
                
                print("iteration              x" + getNextStop() + "f(x)" +
                	getNextStop() + "x - xPrev");
                								
                print("-1" + getPad(10) + x1 + getNextStop() + poly.f(x1) + 
                	getNextStop());

                print("0" + getPad(0) + x2 + getNextStop() + poly.f(x2) +
                	getNextStop() + (x2 - x1));

                tolerance /= Constants.ERROR_FACTOR; 

                if ((poly.f(x1) == 0) || (poly.f(x2) == 0)) {
					hideActiveDialog();
					showOutput();
                    return;
                }

                for (int h = 1; h < MAX_ITERATION; h++) {
                    if ((poly.f(x2) - poly.f(x1)) == 0) {

                        print(Constants.DIV_BY_ZERO);

                        h = MAX_ITERATION;
                        continue;
                    }

                    x3 = x2 - poly.f(x2)*(x2 - x1) / (poly.f(x2) - poly.f(x1));
																		
                    print(h + getPad(h) + x3 + getNextStop() + poly.f(x3) +
                        getNextStop() + (x3 - x2));

                    if ((Math.abs(x3 - x2) < tolerance) || (poly.f(x3) == 0))
                        h = MAX_ITERATION;

                    x1 = x2;
                    x2 = x3;
                }
				
				hideActiveDialog();
				showOutput();
            } //else if(activeDialog == dSecant)

            tToSketch.requestFocus();

        }// else if(source instance of JButton)
    
    } // actionPerformed
    
    private void stopIteration() {
    	if (isIterating) {
    		
    		isIterating = false;
    		iteration = 0;
    	
        	if (rMulti == current)
				tMultiDegree.setEditable(true);

			else if (rNewton == current) 
        		tNewtonTolerance.setEditable(true);
        
			else // if rSecant
        		tSecantTolerance.setEditable(true);  
        
        	current = null;
        	
        	bPrevious.setEnabled(false);
    	}
    }
    
    private void doIteration() {
    	iteration++;
    	
    	polyCanv.printMsg(Constants.FIX_ME + " iteration: " + iteration);
    	
    	if (iteration > 1)
    		bPrevious.setEnabled(true);    		    	
    }
    
    private void doPrevious() {
    	iteration -= 2;
    	
    	if (iteration == 0)
    		bPrevious.setEnabled(false);
    		
    	doIteration(); 
    }
    
    private void doN(int iteration) {

    	isN = false;
    	
		updateNTextFields();
    	polyCanv.printMsg(Constants.FIX_ME + " iteration: " + iteration);
    	this.iteration = 0;	// is this needed? it is safe anyway		
    }
    
    private void updateNTextFields() {
		
		if (rMulti.isSelected()) {
        	lMulti.setText(" degree of accuracy ");
			tMultiDegree.setText(prevText);	
		
		} else if (rNewton.isSelected()) {
        	lNewton.setText(" tolerance ");
			tNewtonTolerance.setText(prevText);
				
        } else if(rSecant.isSelected()) {
        	lSecant.setText(" tolerance ");
			tSecantTolerance.setText(prevText);
		}			    
    }
    
    private void updateTextFields() {
		tTraverseX1.setText(Double.toString(polyCanv.lowX));
        tTraverseX2.setText(Double.toString(polyCanv.highX)); 

        tValueX1.setText(Double.toString(polyCanv.lowX));
        tValueX2.setText(Double.toString(polyCanv.highX));
            
        tMultiX1.setText(Double.toString(polyCanv.lowX));
        tMultiX2.setText(Double.toString(polyCanv.highX));  
    }
    
    private static String getPad(int iteration) {
			// iteration is not expected to reach 100		
		if (iteration < 10)
			return "                          ";
		else 	
			return "                        ";		
	}
	
	private String getNextStop() {		
		String ret = isOdd? "\t                  " : "\t";		
		isOdd = !isOdd;
		
		return ret;
	}
		        
}//##30

class Test
{
	public static void main(String args[]) {
		Frm frm = new Frm();
		frm.setVisible(true);
	}
}
