
/*
 * Copyright (c) Developers of JPolynomial
 * Redistributable and modifiable. Please see license.readme for details.
 *
 * ammendment history
 * <date>			<changed by>		<summary of changes>
 * 27 August 2004	Jonee Ryan Ty		First documented history
 *
 */
 
//import javax.swing.JOptionPane;
//import javax.swing.JFrame;


class TraversalThread		extends Thread {
	private boolean isNotInterrupted = true;
	private boolean isApp = true;
	public PolyCanv polyCanv;
	public App app;
	public Frm frm;
	
	public TraversalThread(PolyCanv polyCanv, Frm frm) {
		this.polyCanv = polyCanv;		
		this.frm = frm;	
		isApp = false;
	}
	
	public TraversalThread(PolyCanv polyCanv, App app) {
		this.polyCanv = polyCanv;		
		this.app = app;
		isApp = true;
	}
	
	public void run() {
		polyCanv.isTraversing = true;
		setBlocked(true);
		
		for(int a = 0; ((a < polyCanv.graphWidth) && (isNotInterrupted)); a++) {
			polyCanv.sweep = PolyCanv.LEFT_MARGIN + a;	
			polyCanv.repaint();
			
			try {
				this.sleep(Constants.ANIM);
			
			} catch(InterruptedException e) {
				isNotInterrupted = false;
			}
		}		
		
		polyCanv.isTraversing = false;
		polyCanv.repaint();

		showOutput();
		setBlocked(false);
		
		app = null;		
		frm = null;
		polyCanv = null;
	}

	private void setBlocked(boolean isBlocked) {
		if (isApp)
			app.setBlocked(isBlocked);
		
		else	
			frm.setBlocked(isBlocked);
	}
	
	private void showOutput() {
		if (isApp)		
			app.showOutput();
		
		else	
			frm.showOutput();
	}
	
}//##30
