
/*
 * Copyright (c) Developers of JPolynomial
 * Redistributable and modifiable. Please see license.readme for details.
 *
 * ammendment history
 * <date>				<changed by>		<summary of changes>
 * 27 August 2004		Jonee Ryan Ty		First documented history
 * 04 December 2004	Jonee Ryan Ty		Linux porting
 */
 
import java.awt.Cursor;
import java.awt.FlowLayout;
//import java.awt.Color;

import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JPanel;
import javax.swing.JButton;
//import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;
import javax.swing.JDialog;
import javax.swing.JCheckBox;
import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;

/**
 * the main gui is set in here
 */
public class PolyApp		extends javax.swing.JApplet
							implements java.awt.event.ActionListener
{            
	public boolean outputShown = false;
	public static final boolean IS_APPLET  = true;

    public JTextField 	tToSketch,
						tfxToNested,
						tfpxToNested,
						tx, tfx, tfpx,
						tx1, tx2, ty1, ty2,
						tTraverseX1, tTraverseX2,
						tValueX1, tValueX2, tValueBase, tValueDegree,
						tMultiX1, tMultiX2, tMultiParts, tMultiDegree,
						tInitial, tNewtonTolerance,
						tSecantX0, tSecantX1, tSecantTolerance;

    public JButton  bToGraph,
                    bToNestedForms,
                    bToEval,
                    bProperties,
                    bDo, bPrevious, bIterate, bN,
                    bOk[],
                    bHorner,
                    bCancel[],
                    bShow, 
                    bHide, bCopy, bCopyAll, bClear, bPrint,
                    bC;

    public JRadioButton rTraverse, rValue, rMulti, rNewton, rSecant,
                        rNormal, rFramed, rNone;
    
    public ButtonGroup axis, algo;   
        
    public JDialog  activeDialog,
                    dToNested, dToEval, dProperties,
                    dTraverse, dValue, dMulti, dNewton, dSecant;

	public JLabel lMulti, lNewton, lSecant;
	
    public JCheckBox showLabels;
    public JTextArea text;

    public PolyCanv polyCanv;
    public Polynomial poly = null;
    	
    public JFrame fOutput;
    
    private JFrame invisible;
    	
    private JScrollPane outputScroll;

    private JPanel  p1, p2, p3, p4, p5,
                    p6, p7,
                    p8,
                    p9, p10,
                    p11,
                    p12, p13, p14,
                    p15, p16, p17,
                    p18, p19,
                    p20, p21,
                    pOkCancel[], pTitled,
                    pOutput;

    public void init() {
        super.init();

        this.setSize(SizeConstants.APP_WIDTH, SizeConstants.APP_HEIGHT);
        this.setup();
    }

	private void setup() {
		tToSketch           = new JTextField("x^3 - 2", 25);
		tfxToNested         = new JTextField(25);
		tfpxToNested        = new JTextField(25);
		tx                  = new JTextField(7);
		tfx                 = new JTextField(7);
		tfpx                = new JTextField(7);
		tx1                 = new JTextField("-5", 5);
		tx2                 = new JTextField("5", 5);
		ty1                 = new JTextField("-10", 5);
		ty2                 = new JTextField("10", 5);
		tTraverseX1         = new JTextField("-5", 5);
		tTraverseX2         = new JTextField("5", 5);
		tValueX1            = new JTextField("-5", 5);
		tValueX2            = new JTextField("5", 5);
		tValueBase          = new JTextField("16", 5);
		tValueDegree        = new JTextField("10", 5);
		tMultiX1            = new JTextField("-5", 5);
		tMultiX2            = new JTextField("5", 5);
		tMultiDegree        = new JTextField("10", 5);
		tMultiParts         = new JTextField("4", 5);
		tInitial            = new JTextField("0", 5);
		tNewtonTolerance    = new JTextField("5e-11", 5);
		tSecantX0           = new JTextField("0", 5);
		tSecantX1           = new JTextField("1", 5);
		tSecantTolerance    = new JTextField("5e-11", 5);

		tToSketch.setToolTipText(
			"Enter a polynomial string such as \"x^2 + 2x - 5\"");
		tx.setToolTipText("you may press enter");

		tToSketch.addActionListener(this);
		tx.addActionListener(this);

		tToSketch.requestFocus();

		tfxToNested.setEditable(false);
		tfpxToNested.setEditable(false);
		tfx.setEditable(false);
		tfpx.setEditable(false);

		bC				= new JButton(" C ");
		bToGraph 		= new JButton(" to graph ");
		bToNestedForms  = new JButton(" to nested form ");
		bToEval			= new JButton(" to evaluate ");
		bProperties		= new JButton(" properties ");
		bDo				= new JButton(" do ");
		bShow			= new JButton(" show output ");
		bHide			= new JButton(" hide ");
		bClear			= new JButton(" clear ");
		bCopy			= new JButton(" copy selected ");
		bCopyAll		= new JButton(" copy all ");
		bPrint			= new JButton(" print ");
		bIterate		= new JButton(" iterate ");
		bPrevious		= new JButton(" previous ");
		bN				= new JButton(" nth iteration ");
		bHorner			= new JButton(" evaluate ");

		bC.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bToGraph.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bToNestedForms.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bToEval.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bProperties.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bDo.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bShow.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bHide.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bCopy.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bCopyAll.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bClear.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bPrint.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bIterate.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bPrevious.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bN.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bHorner.setCursor(new Cursor(Cursor.HAND_CURSOR));

		bC.addActionListener(this);
		bToGraph.addActionListener(this);
		bToNestedForms.addActionListener(this);
		bToEval.addActionListener(this);
		bProperties.addActionListener(this);
		bDo.addActionListener(this);
		bShow.addActionListener(this);

		bHide.addActionListener(this);
		bCopy.addActionListener(this);
		bCopyAll.addActionListener(this);
		bClear.addActionListener(this);
		bPrint.addActionListener(this);

		bIterate.addActionListener(this);
		bN.addActionListener(this);
		bPrevious.addActionListener(this);
		bHorner.addActionListener(this);

		bIterate.setEnabled(false);
		bN.setEnabled(false);
		bPrevious.setEnabled(false);

		bOk = new JButton[8];

		for(int a = 0; a < bOk.length; a++) {
			bOk[a] = new JButton(Constants.OK_LABEL);
			bOk[a].setCursor(new Cursor(Cursor.HAND_CURSOR));
			bOk[a].addActionListener(this);
		}

		bCancel	= new JButton[6];
		pOkCancel = new JPanel[6];

		for(int b = 0; b < bCancel.length; b++) {
			bCancel[b] = new JButton(Constants.CANCEL_LABEL);
			bCancel[b].setCursor(new Cursor(Cursor.HAND_CURSOR));
			bCancel[b].addActionListener(this);
			pOkCancel[b] = new JPanel(new FlowLayout(FlowLayout.CENTER, 6, 0));
		}

		showLabels = new JCheckBox("labels on?", true);
		showLabels.setCursor(new Cursor(Cursor.HAND_CURSOR));
		showLabels.addActionListener(this);

		text = new JTextArea(18, 42);
		text.setEditable(false);
		text.setCursor(new Cursor(Cursor.TEXT_CURSOR));
		text.setTabSize(Constants.TAB_SIZE);

		polyCanv = new PolyCanv();
		polyCanv.whereToPrint = text;
		polyCanv.repaint();

		rTraverse   = new JRadioButton(" traverse the graph ", true);
		rValue      = new JRadioButton(" value differentiation ");
		rMulti      = new JRadioButton(" multisection ");
		rNewton     = new JRadioButton(" Newton ");
		rSecant     = new JRadioButton(" secant ");

		rNormal     = new JRadioButton(" normal ", true);
		rFramed     = new JRadioButton(" framed ");
		rNone       = new JRadioButton(" none ");

		rTraverse.addActionListener(this);
		rValue.addActionListener(this);
		rMulti.addActionListener(this);
		rNewton.addActionListener(this);
		rSecant.addActionListener(this);

		rNormal.addActionListener(this);
		rFramed.addActionListener(this);
		rNone.addActionListener(this);

		axis = new ButtonGroup();
		algo = new ButtonGroup();

		algo.add(rTraverse);
		algo.add(rValue);
		algo.add(rMulti);
		algo.add(rNewton);
		algo.add(rSecant);

		axis.add(rNormal);
		axis.add(rFramed);
		axis.add(rNone);

		p1 = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 0));
		p1.add(new JLabel(" Polynomial to sketch [f(x)]:"));
		p1.add(tToSketch);
		p1.add(bC);

		p2 = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 0));
		p2.add(bToGraph);
		p2.add(bToNestedForms);
		p2.add(bToEval);
		p2.add(bProperties);

		p3 = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 0));
		p3.add(rTraverse);
		p3.add(rValue);

		p4 = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 0));
		p4.add(rMulti);
		p4.add(rNewton);
		p4.add(rSecant);

		p5 = new JPanel(new FlowLayout(FlowLayout.LEFT, 6, 0));
		p5.add(bDo);
		p5.add(bPrevious);
		p5.add(bIterate);
		p5.add(bN);
		p5.add(bShow);

		pTitled = new JPanel(new java.awt.GridLayout(2, 1));
		pTitled.add(p3);
		pTitled.add(p4);

		pTitled.setBorder(BorderFactory.createTitledBorder(
		pTitled.getBorder(), "Polynomial root finding algorithms"));

		java.awt.Container contentPane = this.getContentPane();
		contentPane.setLayout(
			new FlowLayout(FlowLayout.CENTER, this.getWidth(), 12));

		contentPane.add(p1);
		contentPane.add(p2);
		contentPane.add(polyCanv);
		contentPane.add(pTitled);
		contentPane.add(p5);

		p6 = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 0));
		p6.add(new JLabel(" f(x) = "));
		p6.add(tfxToNested);

		p7 = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 0));
		p7.add(new JLabel("f'(x) = "));
		p7.add(tfpxToNested);

		invisible = new JFrame();

		dToNested = new JDialog(invisible, Constants.PROJECT_TITLE, false);
		dToNested.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		dToNested.setSize(SizeConstants.D_TO_NESTED_WIDTH,
			SizeConstants.D_TO_NESTED_HEIGHT + ((IS_APPLET)? SizeConstants.APPLET_ADD_HEIGHT : 0));
		dToNested.setResizable(false);

		contentPane = dToNested.getContentPane();	// to re-use variable
		contentPane.setLayout(new FlowLayout(FlowLayout.CENTER, 0, 12));
		contentPane.add(new JLabel("Nested forms:"));
		contentPane.add(p6);
		contentPane.add(p7);
		contentPane.add(bOk[0]);

		p8 = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 0));
		p8.add(new JLabel("  x = "));
		p8.add(tx);
		p8.add(new JLabel("    f(x) = "));
		p8.add(tfx);
		p8.add(new JLabel("    f'(x) = "));
		p8.add(tfpx);

		dToEval = new JDialog(invisible, Constants.PROJECT_TITLE, false);
		dToEval.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		dToEval.setSize(SizeConstants.D_TO_EVAL_WIDTH,
			SizeConstants.D_TO_EVAL_HEIGHT + ((IS_APPLET)? SizeConstants.APPLET_ADD_HEIGHT : 0));
		dToEval.setResizable(false);

		contentPane = dToEval.getContentPane();	// to re-use variable
		contentPane.setLayout(new FlowLayout(FlowLayout.CENTER, 6, 14));
		contentPane.add(new JLabel("Evaluation using Horner's method"));
		contentPane.add(p8);
		contentPane.add(bHorner);
		contentPane.add(bOk[1]);
		bOk[1].setText(Constants.CANCEL_LABEL);		/**/

		p9 = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 0));
		p9.add(new JLabel(" view intervals    x: "));
		p9.add(tx1);
		p9.add(new JLabel(" to "));
		p9.add(tx2);
		p9.add(new JLabel("  y: "));
		p9.add(ty1);
		p9.add(new JLabel(" to "));
		p9.add(ty2);

		p10 = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 0));
		p10.add(new JLabel(" axis type "));
		p10.add(rNormal);
		p10.add(rFramed);
		p10.add(rNone);
		p10.add(showLabels);

		dProperties = new JDialog(invisible, Constants.PROJECT_TITLE, false);
		dProperties.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		dProperties.setSize(SizeConstants.D_PROPERTIES_WIDTH,
			SizeConstants.D_PROPERTIES_HEIGHT + ((IS_APPLET)? SizeConstants.APPLET_ADD_HEIGHT : 0));
		dProperties.setResizable(false);

		contentPane = dProperties.getContentPane();	// to re-use variable
		contentPane.setLayout(new FlowLayout(FlowLayout.CENTER, 0, 10));
		contentPane.add(new JLabel(" Frame Properties "));
		contentPane.add(p9);
		contentPane.add(p10);
		pOkCancel[0].add(bOk[2]);
		pOkCancel[0].add(bCancel[0]);
		contentPane.add(pOkCancel[0]);

		p11 = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 0));
		p11.add(new JLabel(" interval x: "));
		p11.add(tTraverseX1);
		p11.add(new JLabel(" to "));
		p11.add(tTraverseX2);

		dTraverse = new JDialog(invisible, Constants.PROJECT_TITLE, false);
		dTraverse.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		dTraverse.setSize(SizeConstants.D_TRAVERSE_WIDTH,
			SizeConstants.D_TRAVERSE_HEIGHT + ((IS_APPLET)? SizeConstants.APPLET_ADD_HEIGHT : 0));
		dTraverse.setResizable(false);
			// to re-use variable
		contentPane = dTraverse.getContentPane();
		contentPane.setLayout(new FlowLayout(FlowLayout.CENTER, 0, 14));
		contentPane.add(new JLabel(" Traverse the graph "));
		contentPane.add(p11);
		pOkCancel[1].add(bOk[3]);
		pOkCancel[1].add(bCancel[1]);
		contentPane.add(pOkCancel[1]);

		p12 = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 0));
		p12.add(new JLabel(" IVT interval x: "));
		p12.add(tValueX1);
		p12.add(new JLabel(" to "));
		p12.add(tValueX2);

		p13 = new JPanel(new FlowLayout(FlowLayout.LEFT, 14, 0));
		p13.add(new JLabel(" base "));
		p13.add(tValueBase);

		p14 = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 0));
		p14.add(new JLabel(" degree of accuracy "));
		p14.add(tValueDegree);

		dValue = new JDialog(invisible, Constants.PROJECT_TITLE, false);
		dValue.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		dValue.setSize(SizeConstants.D_VALUE_WIDTH,
			SizeConstants.D_VALUE_HEIGHT + ((IS_APPLET)? SizeConstants.APPLET_ADD_HEIGHT : 0));
		dValue.setResizable(false);

		contentPane = dValue.getContentPane();	// to re-use variable
		contentPane.setLayout(new FlowLayout(FlowLayout.CENTER,
		dValue.getWidth(), 10));
		contentPane.add(new JLabel(" Value differentiation "));
		contentPane.add(p12);
		contentPane.add(p13);
		contentPane.add(p14);
		pOkCancel[2].add(bOk[4]);
		pOkCancel[2].add(bCancel[2]);
		contentPane.add(pOkCancel[2]);

		p15 = new JPanel(new FlowLayout(FlowLayout.LEFT, 12, 0));
		p15.add(new JLabel(" IVT interval x: "));
		p15.add(tMultiX1);
		p15.add(new JLabel(" to "));
		p15.add(tMultiX2);

		p16 = new JPanel(new FlowLayout(FlowLayout.LEFT, 12, 0));
		p16.add(new JLabel(" number of partitions "));
		p16.add(tMultiParts);

		p17 = new JPanel(new FlowLayout(FlowLayout.LEFT, 12, 0));
		lMulti = new JLabel(" degree of accuracy ");
		p17.add(lMulti);
		p17.add(tMultiDegree);

		dMulti = new JDialog(invisible, Constants.PROJECT_TITLE, false);
		dMulti.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		dMulti.setSize(SizeConstants.D_MULTI_WIDTH,
			SizeConstants.D_MULTI_HEIGHT + ((IS_APPLET)? SizeConstants.APPLET_ADD_HEIGHT : 0));
		dMulti.setResizable(false);

		contentPane = dMulti.getContentPane();	// to re-use variable
		contentPane.setLayout(new FlowLayout(FlowLayout.CENTER,
		dMulti.getWidth(), 10));
		contentPane.add(new JLabel(" Multisection method "));
		contentPane.add(p15);
		contentPane.add(p16);
		contentPane.add(p17);
		pOkCancel[3].add(bOk[5]);
		pOkCancel[3].add(bCancel[3]);
		contentPane.add(pOkCancel[3]);

		p18 = new JPanel(new FlowLayout(FlowLayout.LEFT, 12, 0));
		p18.add(new JLabel(" initial guess "));
		p18.add(tInitial);

		p19 = new JPanel(new FlowLayout(FlowLayout.LEFT, 12, 0));
		lNewton = new JLabel(" tolerance ");
		p19.add(lNewton);
		p19.add(tNewtonTolerance);

		dNewton = new JDialog(invisible, Constants.PROJECT_TITLE, false);
		dNewton.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		dNewton.setSize(SizeConstants.D_NEWTON_WIDTH,
			SizeConstants.D_NEWTON_HEIGHT + ((IS_APPLET)? SizeConstants.APPLET_ADD_HEIGHT : 0));
		dNewton.setResizable(false);

		contentPane = dNewton.getContentPane();	// to re-use variable
		contentPane.setLayout(new FlowLayout(FlowLayout.CENTER,
		dNewton.getWidth(), 12));
		contentPane.add(new JLabel(" Newton method "));
		contentPane.add(p18);
		contentPane.add(p19);
		pOkCancel[4].add(bOk[6]);
		pOkCancel[4].add(bCancel[4]);
		contentPane.add(pOkCancel[4]);

		p20 = new JPanel(new FlowLayout(FlowLayout.LEFT, 12, 0));
		p20.add(new JLabel(" x0 = "));
		p20.add(tSecantX0);
		p20.add(new JLabel(" x1 = "));
		p20.add(tSecantX1);

		p21 = new JPanel(new FlowLayout(FlowLayout.LEFT, 12, 0));
		lSecant = new JLabel(" tolerance ");
		p21.add(lSecant);
		p21.add(tSecantTolerance);

		dSecant = new JDialog(invisible, Constants.PROJECT_TITLE, false);
		dSecant.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		dSecant.setSize(SizeConstants.D_SECANT_WIDTH,
			SizeConstants.D_SECANT_HEIGHT + ((IS_APPLET)? SizeConstants.APPLET_ADD_HEIGHT : 0));
		dSecant.setResizable(false);

		contentPane = dSecant.getContentPane();	// to re-use variable
		contentPane.setLayout(new FlowLayout(FlowLayout.CENTER,
		dSecant.getWidth(), Constants.VSPACING));
		contentPane.add(new JLabel(" Secant method "));
		contentPane.add(p20);
		contentPane.add(p21);
		pOkCancel[5].add(bOk[7]);
		pOkCancel[5].add(bCancel[5]);
		contentPane.add(pOkCancel[5]);

		fOutput = new JFrame(Constants.PROJECT_TITLE + " ");
		fOutput.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
		fOutput.setSize(SizeConstants.F_OUTPUT_WIDTH,
			SizeConstants.F_OUTPUT_HEIGHT + ((IS_APPLET)? SizeConstants.APPLET_ADD_HEIGHT : 0));
		//fOutput.setResizable(false);

		outputScroll = new JScrollPane(text);
		pOutput = new JPanel(new FlowLayout(FlowLayout.LEFT, 12, 0));

		pOutput.add(bClear);
		pOutput.add(bCopy);
		pOutput.add(bCopyAll);
		pOutput.add(bPrint);
		pOutput.add(bHide);

		contentPane = fOutput.getContentPane(); // to re-use variable
		contentPane.setLayout(new FlowLayout(FlowLayout.CENTER,
			fOutput.getWidth(), Constants.VSPACING));
		contentPane.add(outputScroll);
		contentPane.add(pOutput);

	} // setup()

    public void actionPerformed(java.awt.event.ActionEvent e) {}

    public void setBlocked(boolean isBlocked) {
        tToSketch.setEnabled(!isBlocked);
        bToGraph.setEnabled(!isBlocked);
        bToEval.setEnabled(!isBlocked);
        bToNestedForms.setEnabled(!isBlocked);
        bProperties.setEnabled(!isBlocked);

        bDo.setEnabled(!isBlocked);
        bIterate.setEnabled(!isBlocked);
        bN.setEnabled(!isBlocked);
		bShow.setEnabled(!isBlocked);
		bC.setEnabled(!isBlocked);

        rTraverse.setEnabled(!isBlocked);
        rValue.setEnabled(!isBlocked);
        rMulti.setEnabled(!isBlocked);
        rNewton.setEnabled(!isBlocked);
        rSecant.setEnabled(!isBlocked);

        polyCanv.setEnabled(!isBlocked);

        if (!isBlocked) {
            if (rTraverse.isSelected() || rValue.isSelected()) {
                bIterate.setEnabled(false);
                bN.setEnabled(false);
        	}

        	bPrevious.setEnabled(false);
        }
    }

    public void showOutput() {
		outputShown = true;
		fOutput.show();
    }

    public void hideOutput() {
    	outputShown = false;
    	fOutput.hide();
    }

    public void hideActiveDialog() {
    	tToSketch.requestFocus();
    	activeDialog.hide();
    }

	public void makeActive(JDialog d) {
		if (activeDialog != null)
			activeDialog.hide();
		activeDialog = d;
        d.show();
	}    
	
    public void showErrorMsg(String err) {
		JOptionPane.showMessageDialog(null, err, 
			Constants.PROJECT_TITLE, JOptionPane.ERROR_MESSAGE);    
    }
    
    public static void print(String toPrint, JTextArea whereTo) {
    	whereTo.append(" " + toPrint + "\n");    	
    }

	public void print(String toPrint) {
		PolyApp.print(toPrint, text);
	}
	
} //##30
